blob: 50323fc27351666440e76ae50806ee480e998da3 [file] [log] [blame]
Jonathan Nieder11d62142013-11-25 13:03:52 -08001# This shell script fragment is sourced by git-rebase to implement
2# its interactive mode. "git rebase --interactive" makes it easy
3# to fix up commits in the middle of a series and rearrange commits.
Johannes Schindelin1b1dce42007-06-25 01:11:14 +01004#
5# Copyright (c) 2006 Johannes E. Schindelin
Johannes Schindelin1b1dce42007-06-25 01:11:14 +01006#
7# The original idea comes from Eric W. Biederman, in
Junio C Hamano5840eb92017-05-08 10:38:59 +09008# https://public-inbox.org/git/m1odwkyuf5.fsf_-_@ebiederm.dsl.xmission.com/
Martin von Zweigbergk572a7c52012-06-26 07:51:54 -07009#
Michael Haggerty80883bb2010-01-14 06:54:45 +010010# The file containing rebase commands, comments, and empty lines.
11# This file is created by "git rebase -i" then edited by the user. As
12# the lines are processed, they are removed from the front of this
Martin von Zweigbergk6bb4e482011-02-06 13:43:37 -050013# file and written to the tail of $done.
Martin von Zweigbergk431b7e72011-02-06 13:43:50 -050014todo="$state_dir"/git-rebase-todo
Michael Haggerty80883bb2010-01-14 06:54:45 +010015
16# The rebase command lines that have already been processed. A line
17# is moved here when it is first handled, before any associated user
18# actions.
Martin von Zweigbergk431b7e72011-02-06 13:43:50 -050019done="$state_dir"/done
Michael Haggerty80883bb2010-01-14 06:54:45 +010020
21# The commit message that is planned to be used for any changes that
22# need to be committed following a user interaction.
Martin von Zweigbergk431b7e72011-02-06 13:43:50 -050023msg="$state_dir"/message
Michael Haggerty80883bb2010-01-14 06:54:45 +010024
25# The file into which is accumulated the suggested commit message for
26# squash/fixup commands. When the first of a series of squash/fixups
27# is seen, the file is created and the commit message from the
28# previous commit and from the first squash/fixup commit are written
29# to it. The commit message for each subsequent squash/fixup commit
30# is appended to the file as it is processed.
31#
32# The first line of the file is of the form
Martin von Zweigbergk6bb4e482011-02-06 13:43:37 -050033# # This is a combination of $count commits.
34# where $count is the number of commits whose messages have been
Michael Haggerty80883bb2010-01-14 06:54:45 +010035# written to the file so far (including the initial "pick" commit).
36# Each time that a commit message is processed, this line is read and
37# updated. It is deleted just before the combined commit is made.
Martin von Zweigbergk431b7e72011-02-06 13:43:50 -050038squash_msg="$state_dir"/message-squash
Michael Haggerty80883bb2010-01-14 06:54:45 +010039
Michael Haggertya25eb132010-01-14 06:54:55 +010040# If the current series of squash/fixups has not yet included a squash
41# command, then this file exists and holds the commit message of the
42# original "pick" commit. (If the series ends without a "squash"
43# command, then this can be used as the commit message of the combined
44# commit without opening the editor.)
Martin von Zweigbergk431b7e72011-02-06 13:43:50 -050045fixup_msg="$state_dir"/message-fixup
Michael Haggertya25eb132010-01-14 06:54:55 +010046
Martin von Zweigbergk6bb4e482011-02-06 13:43:37 -050047# $rewritten is the name of a directory containing files for each
48# commit that is reachable by at least one merge base of $head and
49# $upstream. They are not necessarily rewritten, but their children
Michael Haggerty80883bb2010-01-14 06:54:45 +010050# might be. This ensures that commits on merged, but otherwise
51# unrelated side branches are left alone. (Think "X" in the man page's
52# example.)
Martin von Zweigbergk431b7e72011-02-06 13:43:50 -050053rewritten="$state_dir"/rewritten
Michael Haggerty80883bb2010-01-14 06:54:45 +010054
Martin von Zweigbergk431b7e72011-02-06 13:43:50 -050055dropped="$state_dir"/dropped
Michael Haggerty0aac0de2010-01-14 06:54:46 +010056
Zoltan Klingerb71dc3e2013-04-25 19:28:54 +100057end="$state_dir"/end
58msgnum="$state_dir"/msgnum
59
Michael Haggerty0aac0de2010-01-14 06:54:46 +010060# A script to set the GIT_AUTHOR_NAME, GIT_AUTHOR_EMAIL, and
61# GIT_AUTHOR_DATE that will be used for the commit that is currently
62# being rebased.
Martin von Zweigbergk431b7e72011-02-06 13:43:50 -050063author_script="$state_dir"/author-script
Michael Haggerty0aac0de2010-01-14 06:54:46 +010064
Michael Haggertya4049ae2010-01-14 06:54:47 +010065# When an "edit" rebase command is being processed, the SHA1 of the
66# commit to be edited is recorded in this file. When "git rebase
67# --continue" is executed, if there are any staged changes then they
68# will be amended to the HEAD commit, but only provided the HEAD
69# commit is still the commit to be edited. When any other rebase
70# command is processed, this file is deleted.
Martin von Zweigbergk431b7e72011-02-06 13:43:50 -050071amend="$state_dir"/amend
Michael Haggertya4049ae2010-01-14 06:54:47 +010072
Thomas Rastb079fee2010-03-12 18:04:30 +010073# For the post-rewrite hook, we make a list of rewritten commits and
74# their new sha1s. The rewritten-pending list keeps the sha1s of
75# commits that have been processed, but not committed yet,
76# e.g. because they are waiting for a 'squash' command.
Martin von Zweigbergk431b7e72011-02-06 13:43:50 -050077rewritten_list="$state_dir"/rewritten-list
78rewritten_pending="$state_dir"/rewritten-pending
Thomas Rastb079fee2010-03-12 18:04:30 +010079
Junio C Hamano39743cf2015-10-28 15:54:48 +010080# Work around Git for Windows' Bash whose "read" does not strip CRLF
81# and leaves CR at the end instead.
82cr=$(printf "\015")
83
Fabian Ruch040fd392015-12-11 21:30:36 +010084strategy_args=${strategy:+--strategy=$strategy}
Jeff King8e98b352016-05-10 17:07:10 -040085test -n "$strategy_opts" &&
Fabian Ruch040fd392015-12-11 21:30:36 +010086eval '
87 for strategy_opt in '"$strategy_opts"'
88 do
89 strategy_args="$strategy_args -X$(git rev-parse --sq-quote "${strategy_opt#--}")"
90 done
91'
Arnaud Fontainedb2b3b82013-07-02 17:05:48 +090092
Martin von Zweigbergk89c7ae92011-02-06 13:43:49 -050093GIT_CHERRY_PICK_HELP="$resolvemsg"
Wincent Colaiuta804c7172007-11-28 00:06:36 -080094export GIT_CHERRY_PICK_HELP
95
Johannes Schindelin882cd2372016-11-21 15:18:29 +010096comment_char=$(git config --get core.commentchar 2>/dev/null)
97case "$comment_char" in
98'' | auto)
99 comment_char="#"
100 ;;
101?)
102 ;;
103*)
104 comment_char=$(echo "$comment_char" | cut -c1)
105 ;;
106esac
John Keeping180bad32013-02-11 23:08:04 +0000107
Johannes Schindelin1b1dce42007-06-25 01:11:14 +0100108warn () {
Brandon Casey938791c2010-07-22 14:15:11 -0500109 printf '%s\n' "$*" >&2
Johannes Schindelin1b1dce42007-06-25 01:11:14 +0100110}
111
Michael Haggertyee0a4af2010-01-14 06:54:51 +0100112# Output the commit message for the specified commit.
113commit_message () {
114 git cat-file commit "$1" | sed "1,/^$/d"
115}
116
Martin von Zweigbergk6bb4e482011-02-06 13:43:37 -0500117orig_reflog_action="$GIT_REFLOG_ACTION"
Johannes Schindelin1b1dce42007-06-25 01:11:14 +0100118
119comment_for_reflog () {
Martin von Zweigbergk6bb4e482011-02-06 13:43:37 -0500120 case "$orig_reflog_action" in
Johannes Schindelin1b1dce42007-06-25 01:11:14 +0100121 ''|rebase*)
122 GIT_REFLOG_ACTION="rebase -i ($1)"
123 export GIT_REFLOG_ACTION
Johannes Schindelin376ccb82007-09-25 16:42:51 +0100124 ;;
Johannes Schindelin1b1dce42007-06-25 01:11:14 +0100125 esac
126}
127
Junio C Hamano4e673872008-01-14 20:01:21 -0800128last_count=
Johannes Schindelin1b1dce42007-06-25 01:11:14 +0100129mark_action_done () {
Martin von Zweigbergk6bb4e482011-02-06 13:43:37 -0500130 sed -e 1q < "$todo" >> "$done"
131 sed -e 1d < "$todo" >> "$todo".new
132 mv -f "$todo".new "$todo"
Johannes Sixtd9497512016-07-28 19:47:23 +0200133 new_count=$(( $(git stripspace --strip-comments <"$done" | wc -l) ))
Zoltan Klingerb71dc3e2013-04-25 19:28:54 +1000134 echo $new_count >"$msgnum"
John Keeping180bad32013-02-11 23:08:04 +0000135 total=$(($new_count + $(git stripspace --strip-comments <"$todo" | wc -l)))
Zoltan Klingerb71dc3e2013-04-25 19:28:54 +1000136 echo $total >"$end"
Martin von Zweigbergk6bb4e482011-02-06 13:43:37 -0500137 if test "$last_count" != "$new_count"
Junio C Hamano4e673872008-01-14 20:01:21 -0800138 then
Martin von Zweigbergk6bb4e482011-02-06 13:43:37 -0500139 last_count=$new_count
Vasco Almeida9588c522016-06-17 20:21:03 +0000140 eval_gettext "Rebasing (\$new_count/\$total)"; printf "\r"
Martin von Zweigbergk6bb4e482011-02-06 13:43:37 -0500141 test -z "$verbose" || echo
Junio C Hamano4e673872008-01-14 20:01:21 -0800142 fi
Johannes Schindelin1b1dce42007-06-25 01:11:14 +0100143}
144
Phil Hord8cbc57c2015-04-28 18:55:20 -0400145# Put the last action marked done at the beginning of the todo list
146# again. If there has not been an action marked done yet, leave the list of
147# items on the todo list unchanged.
148reschedule_last_action () {
149 tail -n 1 "$done" | cat - "$todo" >"$todo".new
150 sed -e \$d <"$done" >"$done".new
151 mv -f "$todo".new "$todo"
152 mv -f "$done".new "$done"
153}
154
Andrew Wongfcc5ef12012-09-17 21:28:08 -0400155append_todo_help () {
Vasco Almeidab8fc9e42016-06-17 20:21:04 +0000156 gettext "
John Keeping180bad32013-02-11 23:08:04 +0000157Commands:
Johannes Schindelin4b8b65d2017-07-14 16:45:03 +0200158p, pick = use commit
159r, reword = use commit, but edit the commit message
160e, edit = use commit, but stop for amending
161s, squash = use commit, but meld into previous commit
162f, fixup = like \"squash\", but discard this commit's log message
163x, exec = run command (the rest of the line) using shell
164d, drop = remove commit
John Keeping180bad32013-02-11 23:08:04 +0000165
166These lines can be re-ordered; they are executed from top to bottom.
Vasco Almeidab8fc9e42016-06-17 20:21:04 +0000167" | git stripspace --comment-lines >>"$todo"
John Keeping180bad32013-02-11 23:08:04 +0000168
Galan Rémi37079952015-06-29 22:20:31 +0200169 if test $(get_missing_commit_check_level) = error
170 then
Vasco Almeidab8fc9e42016-06-17 20:21:04 +0000171 gettext "
Galan Rémi37079952015-06-29 22:20:31 +0200172Do not remove any line. Use 'drop' explicitly to remove a commit.
Vasco Almeidab8fc9e42016-06-17 20:21:04 +0000173" | git stripspace --comment-lines >>"$todo"
Galan Rémi37079952015-06-29 22:20:31 +0200174 else
Vasco Almeidab8fc9e42016-06-17 20:21:04 +0000175 gettext "
John Keeping180bad32013-02-11 23:08:04 +0000176If you remove a line here THAT COMMIT WILL BE LOST.
Vasco Almeidab8fc9e42016-06-17 20:21:04 +0000177" | git stripspace --comment-lines >>"$todo"
Galan Rémi37079952015-06-29 22:20:31 +0200178 fi
Andrew Wongfcc5ef12012-09-17 21:28:08 -0400179}
180
Johannes Schindelin1b1dce42007-06-25 01:11:14 +0100181make_patch () {
Johannes Schindelin4fb1a192008-12-22 22:16:51 +0100182 sha1_and_parents="$(git rev-list --parents -1 "$1")"
183 case "$sha1_and_parents" in
184 ?*' '?*' '?*)
185 git diff --cc $sha1_and_parents
186 ;;
187 ?*' '?*)
188 git diff-tree -p "$1^!"
189 ;;
190 *)
191 echo "Root commit"
192 ;;
Martin von Zweigbergk431b7e72011-02-06 13:43:50 -0500193 esac > "$state_dir"/patch
Martin von Zweigbergk6bb4e482011-02-06 13:43:37 -0500194 test -f "$msg" ||
195 commit_message "$1" > "$msg"
196 test -f "$author_script" ||
197 get_author_ident_from_commit "$1" > "$author_script"
Johannes Schindelin1b1dce42007-06-25 01:11:14 +0100198}
199
200die_with_patch () {
Martin von Zweigbergk431b7e72011-02-06 13:43:50 -0500201 echo "$1" > "$state_dir"/stopped-sha
Nguyễn Thái Ngọc Duyfbd7a232018-02-11 16:43:28 +0700202 git update-ref REBASE_HEAD "$1"
Johannes Schindelin1b1dce42007-06-25 01:11:14 +0100203 make_patch "$1"
204 die "$2"
205}
206
Andrew Wong0becb3e2011-11-30 10:52:51 -0500207exit_with_patch () {
208 echo "$1" > "$state_dir"/stopped-sha
Nguyễn Thái Ngọc Duyfbd7a232018-02-11 16:43:28 +0700209 git update-ref REBASE_HEAD "$1"
Andrew Wong0becb3e2011-11-30 10:52:51 -0500210 make_patch $1
211 git rev-parse --verify HEAD > "$amend"
Nicolas Vigier3ee5e542014-02-10 01:03:37 +0000212 gpg_sign_opt_quoted=${gpg_sign_opt:+$(git rev-parse --sq-quote "$gpg_sign_opt")}
Vasco Almeida9588c522016-06-17 20:21:03 +0000213 warn "$(eval_gettext "\
214You can amend the commit now, with
215
216 git commit --amend \$gpg_sign_opt_quoted
217
218Once you are satisfied with your changes, run
219
220 git rebase --continue")"
Andrew Wong0becb3e2011-11-30 10:52:51 -0500221 warn
222 exit $2
223}
224
Johannes Schindelinc54b7812007-06-25 18:56:55 +0100225die_abort () {
Patrick Steinhardt33ba9c62016-06-29 08:21:27 +0200226 apply_autostash
Martin von Zweigbergk431b7e72011-02-06 13:43:50 -0500227 rm -rf "$state_dir"
Johannes Schindelinc54b7812007-06-25 18:56:55 +0100228 die "$1"
229}
230
Johannes Schindelin376ccb82007-09-25 16:42:51 +0100231has_action () {
John Keeping180bad32013-02-11 23:08:04 +0000232 test -n "$(git stripspace --strip-comments <"$1")"
Johannes Schindelin376ccb82007-09-25 16:42:51 +0100233}
234
Neil Horman90e18182012-04-20 10:36:17 -0400235is_empty_commit() {
Vasco Almeida9588c522016-06-17 20:21:03 +0000236 tree=$(git rev-parse -q --verify "$1"^{tree} 2>/dev/null) || {
237 sha1=$1
238 die "$(eval_gettext "\$sha1: not a commit that can be picked")"
239 }
240 ptree=$(git rev-parse -q --verify "$1"^^{tree} 2>/dev/null) ||
241 ptree=4b825dc642cb6eb9a060e54bf8d69288fbee4904
Neil Horman90e18182012-04-20 10:36:17 -0400242 test "$tree" = "$ptree"
243}
244
Phil Hord98697782013-01-12 15:46:01 -0500245is_merge_commit()
246{
247 git rev-parse --verify --quiet "$1"^2 >/dev/null 2>&1
248}
249
Michael Haggerty7756ecf2010-01-14 06:54:53 +0100250# Run command with GIT_AUTHOR_NAME, GIT_AUTHOR_EMAIL, and
251# GIT_AUTHOR_DATE exported from the current environment.
252do_with_author () {
Junio C Hamano76c9c0d2010-01-22 13:09:24 -0800253 (
254 export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
255 "$@"
256 )
Michael Haggerty7756ecf2010-01-14 06:54:53 +0100257}
258
Peter Oberndorfer821881d2011-10-17 22:26:23 +0200259git_sequence_editor () {
260 if test -z "$GIT_SEQUENCE_EDITOR"
261 then
262 GIT_SEQUENCE_EDITOR="$(git config sequence.editor)"
263 if [ -z "$GIT_SEQUENCE_EDITOR" ]
264 then
265 GIT_SEQUENCE_EDITOR="$(git var GIT_EDITOR)" || return $?
266 fi
267 fi
268
269 eval "$GIT_SEQUENCE_EDITOR" '"$@"'
270}
271
Johannes Schindelin1b1dce42007-06-25 01:11:14 +0100272pick_one () {
Christian Couder8e75abf2010-03-06 21:34:46 +0100273 ff=--ff
Neil Horman90e18182012-04-20 10:36:17 -0400274
Christian Couder8e75abf2010-03-06 21:34:46 +0100275 case "$1" in -n) sha1=$2; ff= ;; *) sha1=$1 ;; esac
Martin von Zweigbergk6bb4e482011-02-06 13:43:37 -0500276 case "$force_rebase" in '') ;; ?*) ff= ;; esac
Vasco Almeida9588c522016-06-17 20:21:03 +0000277 output git rev-parse --verify $sha1 || die "$(eval_gettext "Invalid commit name: \$sha1")"
Neil Horman90e18182012-04-20 10:36:17 -0400278
279 if is_empty_commit "$sha1"
280 then
281 empty_args="--allow-empty"
282 fi
283
Martin von Zweigbergk6bb4e482011-02-06 13:43:37 -0500284 test -d "$rewritten" &&
Johannes Schindelinf09c9b82007-06-25 18:59:43 +0100285 pick_one_preserving_merges "$@" && return
Genki Skya6c612b2018-02-04 15:08:13 -0500286 output eval git cherry-pick $allow_rerere_autoupdate $allow_empty_message \
Nicolas Vigier3ee5e542014-02-10 01:03:37 +0000287 ${gpg_sign_opt:+$(git rev-parse --sq-quote "$gpg_sign_opt")} \
288 "$strategy_args" $empty_args $ff "$@"
Phil Hord8cbc57c2015-04-28 18:55:20 -0400289
290 # If cherry-pick dies it leaves the to-be-picked commit unrecorded. Reschedule
291 # previous task so this commit is not lost.
292 ret=$?
293 case "$ret" in [01]) ;; *) reschedule_last_action ;; esac
294 return $ret
Johannes Schindelin1b1dce42007-06-25 01:11:14 +0100295}
296
Johannes Schindelinf09c9b82007-06-25 18:59:43 +0100297pick_one_preserving_merges () {
Thomas Rast71d94512008-08-13 23:41:23 +0200298 fast_forward=t
299 case "$1" in
300 -n)
301 fast_forward=f
302 sha1=$2
303 ;;
304 *)
305 sha1=$1
306 ;;
307 esac
Johannes Schindelinf09c9b82007-06-25 18:59:43 +0100308 sha1=$(git rev-parse $sha1)
309
Wink Saville0c4030c2018-03-22 21:39:52 -0700310 if test -f "$state_dir"/current-commit && test "$fast_forward" = t
Johannes Schindelinf09c9b82007-06-25 18:59:43 +0100311 then
Wink Saville0c4030c2018-03-22 21:39:52 -0700312 while read current_commit
313 do
314 git rev-parse HEAD > "$rewritten"/$current_commit
315 done <"$state_dir"/current-commit
316 rm "$state_dir"/current-commit ||
317 die "$(gettext "Cannot write current commit's replacement sha1")"
Johannes Schindelinf09c9b82007-06-25 18:59:43 +0100318 fi
319
Martin von Zweigbergk431b7e72011-02-06 13:43:50 -0500320 echo $sha1 >> "$state_dir"/current-commit
Thomas Rasta96dc012008-08-13 23:41:24 +0200321
Johannes Schindelinf09c9b82007-06-25 18:59:43 +0100322 # rewrite parents; if none were rewritten, we can fast-forward.
Johannes Schindelinf09c9b82007-06-25 18:59:43 +0100323 new_parents=
Thomas Rastd911d142009-01-02 23:28:28 +0100324 pend=" $(git rev-list --parents -1 $sha1 | cut -d' ' -s -f2-)"
325 if test "$pend" = " "
326 then
327 pend=" root"
328 fi
Stephen Habermanfaae8532008-10-05 23:26:52 -0500329 while [ "$pend" != "" ]
Johannes Schindelinf09c9b82007-06-25 18:59:43 +0100330 do
Stephen Habermanfaae8532008-10-05 23:26:52 -0500331 p=$(expr "$pend" : ' \([^ ]*\)')
332 pend="${pend# $p}"
333
Martin von Zweigbergk6bb4e482011-02-06 13:43:37 -0500334 if test -f "$rewritten"/$p
Johannes Schindelinf09c9b82007-06-25 18:59:43 +0100335 then
Martin von Zweigbergk6bb4e482011-02-06 13:43:37 -0500336 new_p=$(cat "$rewritten"/$p)
Stephen Haberman80fe82e2008-10-15 02:44:40 -0500337
338 # If the todo reordered commits, and our parent is marked for
339 # rewriting, but hasn't been gotten to yet, assume the user meant to
340 # drop it on top of the current HEAD
341 if test -z "$new_p"
342 then
343 new_p=$(git rev-parse HEAD)
344 fi
345
Johannes Schindelinf09c9b82007-06-25 18:59:43 +0100346 test $p != $new_p && fast_forward=f
347 case "$new_parents" in
348 *$new_p*)
349 ;; # do nothing; that parent is already there
350 *)
351 new_parents="$new_parents $new_p"
Johannes Schindelin376ccb82007-09-25 16:42:51 +0100352 ;;
Johannes Schindelinf09c9b82007-06-25 18:59:43 +0100353 esac
Stephan Beyer1c5fa0a2008-07-16 03:51:49 +0200354 else
Martin von Zweigbergk6bb4e482011-02-06 13:43:37 -0500355 if test -f "$dropped"/$p
Stephen Habermanfaae8532008-10-05 23:26:52 -0500356 then
357 fast_forward=f
Martin von Zweigbergk6bb4e482011-02-06 13:43:37 -0500358 replacement="$(cat "$dropped"/$p)"
Thomas Rastd911d142009-01-02 23:28:28 +0100359 test -z "$replacement" && replacement=root
360 pend=" $replacement$pend"
Stephen Habermanfaae8532008-10-05 23:26:52 -0500361 else
362 new_parents="$new_parents $p"
363 fi
Johannes Schindelinf09c9b82007-06-25 18:59:43 +0100364 fi
365 done
366 case $fast_forward in
367 t)
Vasco Almeida9588c522016-06-17 20:21:03 +0000368 output warn "$(eval_gettext "Fast-forward to \$sha1")"
Thomas Rast71d94512008-08-13 23:41:23 +0200369 output git reset --hard $sha1 ||
Vasco Almeida9588c522016-06-17 20:21:03 +0000370 die "$(eval_gettext "Cannot fast-forward to \$sha1")"
Johannes Schindelinf09c9b82007-06-25 18:59:43 +0100371 ;;
372 f)
Johannes Schindelin376ccb82007-09-25 16:42:51 +0100373 first_parent=$(expr "$new_parents" : ' \([^ ]*\)')
Stephen Habermana4f25e32008-10-15 02:44:37 -0500374
375 if [ "$1" != "-n" ]
376 then
377 # detach HEAD to current parent
378 output git checkout $first_parent 2> /dev/null ||
Vasco Almeida9588c522016-06-17 20:21:03 +0000379 die "$(eval_gettext "Cannot move HEAD to \$first_parent")"
Stephen Habermana4f25e32008-10-15 02:44:37 -0500380 fi
Johannes Schindelinf09c9b82007-06-25 18:59:43 +0100381
Johannes Schindelinf09c9b82007-06-25 18:59:43 +0100382 case "$new_parents" in
Johannes Schindelin376ccb82007-09-25 16:42:51 +0100383 ' '*' '*)
Vasco Almeida9588c522016-06-17 20:21:03 +0000384 test "a$1" = a-n && die "$(eval_gettext "Refusing to squash a merge: \$sha1")"
Stephen Habermana4f25e32008-10-15 02:44:37 -0500385
Johannes Schindelinf09c9b82007-06-25 18:59:43 +0100386 # redo merge
Martin von Zweigbergk6bb4e482011-02-06 13:43:37 -0500387 author_script_content=$(get_author_ident_from_commit $sha1)
388 eval "$author_script_content"
389 msg_content="$(commit_message $sha1)"
Björn Steinbrinkf91333d2007-10-31 03:20:32 +0100390 # No point in merging the first parent, that's HEAD
391 new_parents=${new_parents# $first_parent}
Ralf Thielowa9f739c2013-08-21 20:48:57 +0200392 merge_args="--no-log --no-ff"
Arnaud Fontainedb2b3b82013-07-02 17:05:48 +0900393 if ! do_with_author output eval \
Johannes Schindelindd6fb002018-01-04 22:31:52 +0100394 git merge ${gpg_sign_opt:+$(git rev-parse \
395 --sq-quote "$gpg_sign_opt")} \
396 $allow_rerere_autoupdate "$merge_args" \
397 "$strategy_args" \
Gregory Herreroed5144d2018-02-08 21:42:41 +0100398 -m "$(git rev-parse --sq-quote "$msg_content")" \
Johannes Schindelindd6fb002018-01-04 22:31:52 +0100399 "$new_parents"
Johannes Schindelinf09c9b82007-06-25 18:59:43 +0100400 then
Martin von Zweigbergk6bb4e482011-02-06 13:43:37 -0500401 printf "%s\n" "$msg_content" > "$GIT_DIR"/MERGE_MSG
Vasco Almeida9588c522016-06-17 20:21:03 +0000402 die_with_patch $sha1 "$(eval_gettext "Error redoing merge \$sha1")"
Johannes Schindelinf09c9b82007-06-25 18:59:43 +0100403 fi
Martin von Zweigbergk6bb4e482011-02-06 13:43:37 -0500404 echo "$sha1 $(git rev-parse HEAD^0)" >> "$rewritten_list"
Johannes Schindelinf09c9b82007-06-25 18:59:43 +0100405 ;;
406 *)
Phillip Wood9b6d7a62017-08-02 11:44:17 +0100407 output eval git cherry-pick $allow_rerere_autoupdate \
Genki Skya6c612b2018-02-04 15:08:13 -0500408 $allow_empty_message \
Nicolas Vigier3ee5e542014-02-10 01:03:37 +0000409 ${gpg_sign_opt:+$(git rev-parse --sq-quote "$gpg_sign_opt")} \
410 "$strategy_args" "$@" ||
Vasco Almeida9588c522016-06-17 20:21:03 +0000411 die_with_patch $sha1 "$(eval_gettext "Could not pick \$sha1")"
Johannes Schindelin376ccb82007-09-25 16:42:51 +0100412 ;;
Johannes Schindelinf09c9b82007-06-25 18:59:43 +0100413 esac
Johannes Schindelin376ccb82007-09-25 16:42:51 +0100414 ;;
Johannes Schindelinf09c9b82007-06-25 18:59:43 +0100415 esac
416}
417
Vasco Almeidaf2d17062016-06-17 20:21:05 +0000418this_nth_commit_message () {
419 n=$1
Jean-Noel Avila8aa6dc12016-08-21 16:50:38 +0200420 eval_gettext "This is the commit message #\${n}:"
Vasco Almeidaf2d17062016-06-17 20:21:05 +0000421}
Jean-Noel Avila8aa6dc12016-08-21 16:50:38 +0200422
Vasco Almeidaf2d17062016-06-17 20:21:05 +0000423skip_nth_commit_message () {
424 n=$1
Jean-Noel Avila8aa6dc12016-08-21 16:50:38 +0200425 eval_gettext "The commit message #\${n} will be skipped:"
Johannes Schindelin6368f3f2007-07-21 18:09:41 +0100426}
427
Michael Haggertya25eb132010-01-14 06:54:55 +0100428update_squash_messages () {
Martin von Zweigbergk6bb4e482011-02-06 13:43:37 -0500429 if test -f "$squash_msg"; then
430 mv "$squash_msg" "$squash_msg".bak || exit
431 count=$(($(sed -n \
Jeff King356b8ec2017-01-07 03:23:19 -0500432 -e "1s/^$comment_char[^0-9]*\([0-9][0-9]*\).*/\1/p" \
Martin von Zweigbergk6bb4e482011-02-06 13:43:37 -0500433 -e "q" < "$squash_msg".bak)+1))
Michael Haggertybde1a682010-01-14 06:54:54 +0100434 {
Vasco Almeidaf2d17062016-06-17 20:21:05 +0000435 printf '%s\n' "$comment_char $(eval_ngettext \
436 "This is a combination of \$count commit." \
437 "This is a combination of \$count commits." \
438 $count)"
Michael Haggertybde1a682010-01-14 06:54:54 +0100439 sed -e 1d -e '2,/^./{
440 /^$/d
Martin von Zweigbergk6bb4e482011-02-06 13:43:37 -0500441 }' <"$squash_msg".bak
442 } >"$squash_msg"
Johannes Schindelin6368f3f2007-07-21 18:09:41 +0100443 else
Junio C Hamanoacefe2b2016-12-20 09:36:23 -0800444 commit_message HEAD >"$fixup_msg" ||
445 die "$(eval_gettext "Cannot write \$fixup_msg")"
Martin von Zweigbergk6bb4e482011-02-06 13:43:37 -0500446 count=2
Michael Haggertybde1a682010-01-14 06:54:54 +0100447 {
Vasco Almeidaf2d17062016-06-17 20:21:05 +0000448 printf '%s\n' "$comment_char $(gettext "This is a combination of 2 commits.")"
449 printf '%s\n' "$comment_char $(gettext "This is the 1st commit message:")"
Michael Haggertybde1a682010-01-14 06:54:54 +0100450 echo
Martin von Zweigbergk6bb4e482011-02-06 13:43:37 -0500451 cat "$fixup_msg"
452 } >"$squash_msg"
Johannes Schindelin6368f3f2007-07-21 18:09:41 +0100453 fi
Michael Haggerty0205e722009-12-07 10:20:59 +0100454 case $1 in
455 squash)
Martin von Zweigbergk6bb4e482011-02-06 13:43:37 -0500456 rm -f "$fixup_msg"
Michael Haggerty0205e722009-12-07 10:20:59 +0100457 echo
Vasco Almeidaf2d17062016-06-17 20:21:05 +0000458 printf '%s\n' "$comment_char $(this_nth_commit_message $count)"
Michael Haggerty0205e722009-12-07 10:20:59 +0100459 echo
Michael Haggertyee0a4af2010-01-14 06:54:51 +0100460 commit_message $2
Michael Haggerty0205e722009-12-07 10:20:59 +0100461 ;;
462 fixup)
463 echo
Vasco Almeidaf2d17062016-06-17 20:21:05 +0000464 printf '%s\n' "$comment_char $(skip_nth_commit_message $count)"
Michael Haggerty0205e722009-12-07 10:20:59 +0100465 echo
John Keeping180bad32013-02-11 23:08:04 +0000466 # Change the space after the comment character to TAB:
467 commit_message $2 | git stripspace --comment-lines | sed -e 's/ / /'
Michael Haggerty0205e722009-12-07 10:20:59 +0100468 ;;
Martin von Zweigbergk6bb4e482011-02-06 13:43:37 -0500469 esac >>"$squash_msg"
Johannes Schindelin6368f3f2007-07-21 18:09:41 +0100470}
471
472peek_next_command () {
John Keeping180bad32013-02-11 23:08:04 +0000473 git stripspace --strip-comments <"$todo" | sed -n -e 's/ .*//p' -e q
Johannes Schindelin6368f3f2007-07-21 18:09:41 +0100474}
475
Michael Haggerty6bdcd0d2010-01-14 06:54:57 +0100476# A squash/fixup has failed. Prepare the long version of the squash
477# commit message, then die_with_patch. This code path requires the
478# user to edit the combined commit message for all commits that have
479# been squashed/fixedup so far. So also erase the old squash
480# messages, effectively causing the combined commit to be used as the
481# new basis for any further squash/fixups. Args: sha1 rest
482die_failed_squash() {
Vasco Almeida9588c522016-06-17 20:21:03 +0000483 sha1=$1
484 rest=$2
Martin von Zweigbergk6bb4e482011-02-06 13:43:37 -0500485 mv "$squash_msg" "$msg" || exit
486 rm -f "$fixup_msg"
487 cp "$msg" "$GIT_DIR"/MERGE_MSG || exit
Michael Haggerty6bdcd0d2010-01-14 06:54:57 +0100488 warn
Vasco Almeida9588c522016-06-17 20:21:03 +0000489 warn "$(eval_gettext "Could not apply \$sha1... \$rest")"
490 die_with_patch $sha1 ""
Michael Haggerty6bdcd0d2010-01-14 06:54:57 +0100491}
492
Thomas Rastb079fee2010-03-12 18:04:30 +0100493flush_rewritten_pending() {
Martin von Zweigbergk6bb4e482011-02-06 13:43:37 -0500494 test -s "$rewritten_pending" || return
Thomas Rastb079fee2010-03-12 18:04:30 +0100495 newsha1="$(git rev-parse HEAD^0)"
Martin von Zweigbergk6bb4e482011-02-06 13:43:37 -0500496 sed "s/$/ $newsha1/" < "$rewritten_pending" >> "$rewritten_list"
497 rm -f "$rewritten_pending"
Thomas Rastb079fee2010-03-12 18:04:30 +0100498}
499
500record_in_rewritten() {
501 oldsha1="$(git rev-parse $1)"
Martin von Zweigbergk6bb4e482011-02-06 13:43:37 -0500502 echo "$oldsha1" >> "$rewritten_pending"
Thomas Rastb079fee2010-03-12 18:04:30 +0100503
504 case "$(peek_next_command)" in
Junio C Hamano41f556b2010-07-05 22:16:15 -0700505 squash|s|fixup|f)
Thomas Rastb079fee2010-03-12 18:04:30 +0100506 ;;
Junio C Hamano41f556b2010-07-05 22:16:15 -0700507 *)
Thomas Rastb079fee2010-03-12 18:04:30 +0100508 flush_rewritten_pending
509 ;;
510 esac
511}
512
Chris Webbdf5df202012-06-26 22:55:23 +0100513do_pick () {
Vasco Almeida9588c522016-06-17 20:21:03 +0000514 sha1=$1
515 rest=$2
Chris Webbdf5df202012-06-26 22:55:23 +0100516 if test "$(git rev-parse HEAD)" = "$squash_onto"
517 then
518 # Set the correct commit message and author info on the
519 # sentinel root before cherry-picking the original changes
520 # without committing (-n). Finally, update the sentinel again
521 # to include these changes. If the cherry-pick results in a
522 # conflict, this means our behaviour is similar to a standard
523 # failed cherry-pick during rebase, with a dirty index to
524 # resolve before manually running git commit --amend then git
525 # rebase --continue.
526 git commit --allow-empty --allow-empty-message --amend \
Vasco Almeida9588c522016-06-17 20:21:03 +0000527 --no-post-rewrite -n -q -C $sha1 &&
528 pick_one -n $sha1 &&
Chris Webbdf5df202012-06-26 22:55:23 +0100529 git commit --allow-empty --allow-empty-message \
Vasco Almeida9588c522016-06-17 20:21:03 +0000530 --amend --no-post-rewrite -n -q -C $sha1 \
Nicolas Vigier3ee5e542014-02-10 01:03:37 +0000531 ${gpg_sign_opt:+"$gpg_sign_opt"} ||
Vasco Almeida9588c522016-06-17 20:21:03 +0000532 die_with_patch $sha1 "$(eval_gettext "Could not apply \$sha1... \$rest")"
Chris Webbdf5df202012-06-26 22:55:23 +0100533 else
Vasco Almeida9588c522016-06-17 20:21:03 +0000534 pick_one $sha1 ||
535 die_with_patch $sha1 "$(eval_gettext "Could not apply \$sha1... \$rest")"
Chris Webbdf5df202012-06-26 22:55:23 +0100536 fi
537}
538
Johannes Schindelin1b1dce42007-06-25 01:11:14 +0100539do_next () {
Matthieu Moyb12d3e92015-05-22 13:15:49 +0000540 rm -f "$msg" "$author_script" "$amend" "$state_dir"/stopped-sha || exit
Martin von Zweigbergk6bb4e482011-02-06 13:43:37 -0500541 read -r command sha1 rest < "$todo"
Johannes Schindelin1b1dce42007-06-25 01:11:14 +0100542 case "$command" in
Galan Rémic9266d52015-06-29 22:20:30 +0200543 "$comment_char"*|''|noop|drop|d)
Johannes Schindelin1b1dce42007-06-25 01:11:14 +0100544 mark_action_done
Johannes Schindelin1b1dce42007-06-25 01:11:14 +0100545 ;;
Junio C Hamano39743cf2015-10-28 15:54:48 +0100546 "$cr")
547 # Work around CR left by "read" (e.g. with Git for Windows' Bash).
548 mark_action_done
549 ;;
Johannes Schindelinf8babc42007-09-29 03:32:11 +0100550 pick|p)
Johannes Schindelin1b1dce42007-06-25 01:11:14 +0100551 comment_for_reflog pick
552
553 mark_action_done
Chris Webbdf5df202012-06-26 22:55:23 +0100554 do_pick $sha1 "$rest"
Thomas Rastb079fee2010-03-12 18:04:30 +0100555 record_in_rewritten $sha1
Johannes Schindelin1b1dce42007-06-25 01:11:14 +0100556 ;;
Björn Gustavsson6741aa62009-10-07 08:13:23 +0200557 reword|r)
558 comment_for_reflog reword
559
560 mark_action_done
Chris Webbdf5df202012-06-26 22:55:23 +0100561 do_pick $sha1 "$rest"
Genki Skya6c612b2018-02-04 15:08:13 -0500562 git commit --amend --no-post-rewrite ${gpg_sign_opt:+"$gpg_sign_opt"} \
563 $allow_empty_message || {
Vasco Almeida9588c522016-06-17 20:21:03 +0000564 warn "$(eval_gettext "\
565Could not amend commit after successfully picking \$sha1... \$rest
566This is most likely due to an empty commit message, or the pre-commit hook
567failed. If the pre-commit hook failed, you may need to resolve the issue before
568you are able to reword the commit.")"
Andrew Wong0becb3e2011-11-30 10:52:51 -0500569 exit_with_patch $sha1 1
570 }
Thomas Rastb079fee2010-03-12 18:04:30 +0100571 record_in_rewritten $sha1
Björn Gustavsson6741aa62009-10-07 08:13:23 +0200572 ;;
Johannes Schindelinf8babc42007-09-29 03:32:11 +0100573 edit|e)
Johannes Schindelin1b1dce42007-06-25 01:11:14 +0100574 comment_for_reflog edit
575
576 mark_action_done
Chris Webbdf5df202012-06-26 22:55:23 +0100577 do_pick $sha1 "$rest"
Ralf Thielow14c793e2016-03-28 18:00:00 +0200578 sha1_abbrev=$(git rev-parse --short $sha1)
Vasco Almeida9588c522016-06-17 20:21:03 +0000579 warn "$(eval_gettext "Stopped at \$sha1_abbrev... \$rest")"
Andrew Wong0becb3e2011-11-30 10:52:51 -0500580 exit_with_patch $sha1 0
Johannes Schindelin1b1dce42007-06-25 01:11:14 +0100581 ;;
Michael Haggerty0205e722009-12-07 10:20:59 +0100582 squash|s|fixup|f)
583 case "$command" in
584 squash|s)
585 squash_style=squash
586 ;;
587 fixup|f)
588 squash_style=fixup
589 ;;
590 esac
591 comment_for_reflog $squash_style
Johannes Schindelin1b1dce42007-06-25 01:11:14 +0100592
Martin von Zweigbergk6bb4e482011-02-06 13:43:37 -0500593 test -f "$done" && has_action "$done" ||
Vasco Almeida9588c522016-06-17 20:21:03 +0000594 die "$(eval_gettext "Cannot '\$squash_style' without a previous commit")"
Johannes Schindelin1b1dce42007-06-25 01:11:14 +0100595
596 mark_action_done
Michael Haggertya25eb132010-01-14 06:54:55 +0100597 update_squash_messages $squash_style $sha1
Martin von Zweigbergk6bb4e482011-02-06 13:43:37 -0500598 author_script_content=$(get_author_ident_from_commit HEAD)
599 echo "$author_script_content" > "$author_script"
600 eval "$author_script_content"
Chris Webb2147f842012-07-24 13:17:03 +0100601 if ! pick_one -n $sha1
602 then
603 git rev-parse --verify HEAD >"$amend"
604 die_failed_squash $sha1 "$rest"
605 fi
Johannes Schindelin6368f3f2007-07-21 18:09:41 +0100606 case "$(peek_next_command)" in
Michael Haggerty0205e722009-12-07 10:20:59 +0100607 squash|s|fixup|f)
Michael Haggertya25eb132010-01-14 06:54:55 +0100608 # This is an intermediate commit; its message will only be
609 # used in case of trouble. So use the long version:
Nicolas Vigier3ee5e542014-02-10 01:03:37 +0000610 do_with_author output git commit --amend --no-verify -F "$squash_msg" \
Genki Skya6c612b2018-02-04 15:08:13 -0500611 ${gpg_sign_opt:+"$gpg_sign_opt"} $allow_empty_message ||
Michael Haggerty6bdcd0d2010-01-14 06:54:57 +0100612 die_failed_squash $sha1 "$rest"
Johannes Schindelin376ccb82007-09-25 16:42:51 +0100613 ;;
Johannes Schindelin6368f3f2007-07-21 18:09:41 +0100614 *)
Michael Haggertya25eb132010-01-14 06:54:55 +0100615 # This is the final command of this squash/fixup group
Martin von Zweigbergk6bb4e482011-02-06 13:43:37 -0500616 if test -f "$fixup_msg"
Michael Haggertya25eb132010-01-14 06:54:55 +0100617 then
Nicolas Vigier3ee5e542014-02-10 01:03:37 +0000618 do_with_author git commit --amend --no-verify -F "$fixup_msg" \
Genki Skya6c612b2018-02-04 15:08:13 -0500619 ${gpg_sign_opt:+"$gpg_sign_opt"} $allow_empty_message ||
Michael Haggerty6bdcd0d2010-01-14 06:54:57 +0100620 die_failed_squash $sha1 "$rest"
621 else
Martin von Zweigbergk6bb4e482011-02-06 13:43:37 -0500622 cp "$squash_msg" "$GIT_DIR"/SQUASH_MSG || exit
Michael Haggerty6bdcd0d2010-01-14 06:54:57 +0100623 rm -f "$GIT_DIR"/MERGE_MSG
Nicolas Vigier3ee5e542014-02-10 01:03:37 +0000624 do_with_author git commit --amend --no-verify -F "$GIT_DIR"/SQUASH_MSG -e \
Genki Skya6c612b2018-02-04 15:08:13 -0500625 ${gpg_sign_opt:+"$gpg_sign_opt"} $allow_empty_message ||
Michael Haggerty6bdcd0d2010-01-14 06:54:57 +0100626 die_failed_squash $sha1 "$rest"
Michael Haggertya25eb132010-01-14 06:54:55 +0100627 fi
Martin von Zweigbergk6bb4e482011-02-06 13:43:37 -0500628 rm -f "$squash_msg" "$fixup_msg"
Johannes Schindelin376ccb82007-09-25 16:42:51 +0100629 ;;
Johannes Schindelin6368f3f2007-07-21 18:09:41 +0100630 esac
Thomas Rastb079fee2010-03-12 18:04:30 +0100631 record_in_rewritten $sha1
Johannes Schindelin1b1dce42007-06-25 01:11:14 +0100632 ;;
Matthieu Moycd035b12010-08-10 17:17:51 +0200633 x|"exec")
Martin von Zweigbergk6bb4e482011-02-06 13:43:37 -0500634 read -r command rest < "$todo"
Matthieu Moycd035b12010-08-10 17:17:51 +0200635 mark_action_done
Vasco Almeida9588c522016-06-17 20:21:03 +0000636 eval_gettextln "Executing: \$rest"
Fredrik Medleyfe9394a2015-11-13 07:03:19 +0100637 "${SHELL:-@SHELL_PATH@}" -c "$rest" # Actual execution
Matthieu Moycd035b12010-08-10 17:17:51 +0200638 status=$?
Junio C Hamano16865192011-08-24 11:54:50 -0700639 # Run in subshell because require_clean_work_tree can die.
640 dirty=f
641 (require_clean_work_tree "rebase" 2>/dev/null) || dirty=t
Matthieu Moycd035b12010-08-10 17:17:51 +0200642 if test "$status" -ne 0
643 then
Vasco Almeida9588c522016-06-17 20:21:03 +0000644 warn "$(eval_gettext "Execution failed: \$rest")"
Junio C Hamano16865192011-08-24 11:54:50 -0700645 test "$dirty" = f ||
Vasco Almeida9588c522016-06-17 20:21:03 +0000646 warn "$(gettext "and made changes to the index and/or the working tree")"
Junio C Hamano16865192011-08-24 11:54:50 -0700647
Vasco Almeida9588c522016-06-17 20:21:03 +0000648 warn "$(gettext "\
649You can fix the problem, and then run
650
651 git rebase --continue")"
Matthieu Moycd035b12010-08-10 17:17:51 +0200652 warn
Johannes Sixtecfe1ea2012-09-18 13:15:26 +0200653 if test $status -eq 127 # command not found
654 then
655 status=1
656 fi
Matthieu Moycd035b12010-08-10 17:17:51 +0200657 exit "$status"
Junio C Hamano16865192011-08-24 11:54:50 -0700658 elif test "$dirty" = t
Matthieu Moycd035b12010-08-10 17:17:51 +0200659 then
Vasco Almeida9588c522016-06-17 20:21:03 +0000660 # TRANSLATORS: after these lines is a command to be issued by the user
661 warn "$(eval_gettext "\
662Execution succeeded: \$rest
663but left changes to the index and/or the working tree
664Commit or stash your changes, and then run
665
666 git rebase --continue")"
Matthieu Moycd035b12010-08-10 17:17:51 +0200667 warn
668 exit 1
669 fi
670 ;;
Johannes Schindelin1b1dce42007-06-25 01:11:14 +0100671 *)
Vasco Almeida9588c522016-06-17 20:21:03 +0000672 warn "$(eval_gettext "Unknown command: \$command \$sha1 \$rest")"
673 fixtodo="$(gettext "Please fix this using 'git rebase --edit-todo'.")"
Jan Krügerf1be3162009-10-27 15:58:14 +0100674 if git rev-parse --verify -q "$sha1" >/dev/null
675 then
Johannes Sixt9c8e1012012-09-19 08:43:54 +0200676 die_with_patch $sha1 "$fixtodo"
Jan Krügerf1be3162009-10-27 15:58:14 +0100677 else
Johannes Sixt9c8e1012012-09-19 08:43:54 +0200678 die "$fixtodo"
Jan Krügerf1be3162009-10-27 15:58:14 +0100679 fi
Johannes Schindelin376ccb82007-09-25 16:42:51 +0100680 ;;
Johannes Schindelin1b1dce42007-06-25 01:11:14 +0100681 esac
Martin von Zweigbergk6bb4e482011-02-06 13:43:37 -0500682 test -s "$todo" && return
Johannes Schindelin1b1dce42007-06-25 01:11:14 +0100683
Johannes Schindelin68a163c2007-06-25 18:58:28 +0100684 comment_for_reflog finish &&
Martin von Zweigbergk6bb4e482011-02-06 13:43:37 -0500685 newhead=$(git rev-parse HEAD) &&
Martin von Zweigbergk431b7e72011-02-06 13:43:50 -0500686 case $head_name in
Johannes Schindelin73697a02007-09-25 16:43:15 +0100687 refs/*)
Michael J Gruber1af221e2012-08-10 08:51:19 +0200688 message="$GIT_REFLOG_ACTION: $head_name onto $onto" &&
Martin von Zweigbergk431b7e72011-02-06 13:43:50 -0500689 git update-ref -m "$message" $head_name $newhead $orig_head &&
Jeff King53f2ffa2011-05-27 16:16:14 -0400690 git symbolic-ref \
691 -m "$GIT_REFLOG_ACTION: returning to $head_name" \
692 HEAD $head_name
Johannes Schindelin73697a02007-09-25 16:43:15 +0100693 ;;
694 esac && {
Martin von Zweigbergk431b7e72011-02-06 13:43:50 -0500695 test ! -f "$state_dir"/verbose ||
Martin von Zweigbergk2959c282011-02-06 13:43:52 -0500696 git diff-tree --stat $orig_head..HEAD
Johannes Schindelin3df0a852007-07-08 03:02:13 +0100697 } &&
Thomas Rasteb2151b2010-03-12 18:04:33 +0100698 {
Martin von Zweigbergk6bb4e482011-02-06 13:43:37 -0500699 test -s "$rewritten_list" &&
700 git notes copy --for-rewrite=rebase < "$rewritten_list" ||
Thomas Rasteb2151b2010-03-12 18:04:33 +0100701 true # we don't care if this copying failed
702 } &&
Nguyễn Thái Ngọc Duyb849b952014-11-30 15:24:38 +0700703 hook="$(git rev-parse --git-path hooks/post-rewrite)"
704 if test -x "$hook" && test -s "$rewritten_list"; then
705 "$hook" rebase < "$rewritten_list"
Thomas Rastb079fee2010-03-12 18:04:30 +0100706 true # we don't care if this hook failed
707 fi &&
Vasco Almeida9588c522016-06-17 20:21:03 +0000708 warn "$(eval_gettext "Successfully rebased and updated \$head_name.")"
Johannes Schindelin1b1dce42007-06-25 01:11:14 +0100709
Ramkumar Ramachandra15d4bf22013-05-12 17:26:39 +0530710 return 1 # not failure; just to break the do_rest loop
Johannes Schindelin1b1dce42007-06-25 01:11:14 +0100711}
712
Ramkumar Ramachandra15d4bf22013-05-12 17:26:39 +0530713# can only return 0, when the infinite loop breaks
Johannes Schindelin1b1dce42007-06-25 01:11:14 +0100714do_rest () {
715 while :
716 do
Ramkumar Ramachandra15d4bf22013-05-12 17:26:39 +0530717 do_next || break
Johannes Schindelin1b1dce42007-06-25 01:11:14 +0100718 done
Johannes Schindelin1b1dce42007-06-25 01:11:14 +0100719}
720
Junio C Hamano75c69762013-08-23 20:10:42 -0400721expand_todo_ids() {
Johannes Schindelin3546c8d2017-07-14 16:45:11 +0200722 git rebase--helper --expand-ids
Junio C Hamano75c69762013-08-23 20:10:42 -0400723}
724
725collapse_todo_ids() {
Johannes Schindelin3546c8d2017-07-14 16:45:11 +0200726 git rebase--helper --shorten-ids
Nanako Shiraishif59baa52009-12-08 12:13:14 +0900727}
728
Galan Rémi37079952015-06-29 22:20:31 +0200729# Switch to the branch in $into and notify it in the reflog
730checkout_onto () {
731 GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: checkout $onto_name"
Vasco Almeida9588c522016-06-17 20:21:03 +0000732 output git checkout $onto || die_abort "$(gettext "could not detach HEAD")"
Galan Rémi37079952015-06-29 22:20:31 +0200733 git update-ref ORIG_HEAD $orig_head
734}
735
736get_missing_commit_check_level () {
737 check_level=$(git config --get rebase.missingCommitsCheck)
738 check_level=${check_level:-ignore}
739 # Don't be case sensitive
740 printf '%s' "$check_level" | tr 'A-Z' 'a-z'
741}
742
Wink Saville27c499b2018-03-23 14:25:25 -0700743# Initiate an action. If the cannot be any
744# further action it may exec a command
745# or exit and not return.
746#
747# TODO: Consider a cleaner return model so it
748# never exits and always return 0 if process
749# is complete.
750#
751# Parameter 1 is the action to initiate.
752#
753# Returns 0 if the action was able to complete
754# and if 1 if further processing is required.
755initiate_action () {
756 case "$1" in
Wink Savilled48f97a2018-03-23 14:25:24 -0700757 continue)
758 if test ! -d "$rewritten"
Matthieu Moyffaaed82011-08-24 16:01:48 +0200759 then
Wink Savilled48f97a2018-03-23 14:25:24 -0700760 exec git rebase--helper ${force_rebase:+--no-ff} $allow_empty_message \
761 --continue
762 fi
763 # do we have anything to commit?
764 if git diff-index --cached --quiet HEAD --
765 then
766 # Nothing to commit -- skip this commit
767
768 test ! -f "$GIT_DIR"/CHERRY_PICK_HEAD ||
769 rm "$GIT_DIR"/CHERRY_PICK_HEAD ||
770 die "$(gettext "Could not remove CHERRY_PICK_HEAD")"
771 else
772 if ! test -f "$author_script"
773 then
774 gpg_sign_opt_quoted=${gpg_sign_opt:+$(git rev-parse --sq-quote "$gpg_sign_opt")}
775 die "$(eval_gettext "\
Vasco Almeida9588c522016-06-17 20:21:03 +0000776You have staged changes in your working tree.
777If these changes are meant to be
Matthieu Moyffaaed82011-08-24 16:01:48 +0200778squashed into the previous commit, run:
779
Vasco Almeida9588c522016-06-17 20:21:03 +0000780 git commit --amend \$gpg_sign_opt_quoted
Matthieu Moyffaaed82011-08-24 16:01:48 +0200781
782If they are meant to go into a new commit, run:
783
Vasco Almeida9588c522016-06-17 20:21:03 +0000784 git commit \$gpg_sign_opt_quoted
Matthieu Moyffaaed82011-08-24 16:01:48 +0200785
Alex Henrie7c406bd2016-09-07 22:34:17 -0600786In both cases, once you're done, continue with:
Matthieu Moyffaaed82011-08-24 16:01:48 +0200787
788 git rebase --continue
Vasco Almeida9588c522016-06-17 20:21:03 +0000789")"
Wink Savilled48f97a2018-03-23 14:25:24 -0700790 fi
791 . "$author_script" ||
792 die "$(gettext "Error trying to find the author identity to amend commit")"
793 if test -f "$amend"
794 then
795 current_head=$(git rev-parse --verify HEAD)
796 test "$current_head" = $(cat "$amend") ||
797 die "$(gettext "\
Vasco Almeida9588c522016-06-17 20:21:03 +0000798You have uncommitted changes in your working tree. Please commit them
799first and then run 'git rebase --continue' again.")"
Wink Savilled48f97a2018-03-23 14:25:24 -0700800 do_with_author git commit --amend --no-verify -F "$msg" -e \
801 ${gpg_sign_opt:+"$gpg_sign_opt"} $allow_empty_message ||
802 die "$(gettext "Could not commit staged changes.")"
803 else
804 do_with_author git commit --no-verify -F "$msg" -e \
805 ${gpg_sign_opt:+"$gpg_sign_opt"} $allow_empty_message ||
806 die "$(gettext "Could not commit staged changes.")"
807 fi
Shawn O. Pearce03270622007-12-20 02:12:12 -0500808 fi
Johannes Schindelin18640d92007-07-08 03:01:29 +0100809
Wink Savilled48f97a2018-03-23 14:25:24 -0700810 if test -r "$state_dir"/stopped-sha
811 then
812 record_in_rewritten "$(cat "$state_dir"/stopped-sha)"
813 fi
Thomas Rast0acb62f2010-03-28 21:36:00 +0200814
Wink Savilled48f97a2018-03-23 14:25:24 -0700815 require_clean_work_tree "rebase"
816 do_rest
817 return 0
818 ;;
819 skip)
820 git rerere clear
Johannes Schindelin1b1dce42007-06-25 01:11:14 +0100821
Wink Savilled48f97a2018-03-23 14:25:24 -0700822 if test ! -d "$rewritten"
823 then
824 exec git rebase--helper ${force_rebase:+--no-ff} $allow_empty_message \
825 --continue
826 fi
827 do_rest
828 return 0
829 ;;
830 edit-todo)
831 git stripspace --strip-comments <"$todo" >"$todo".new
832 mv -f "$todo".new "$todo"
833 collapse_todo_ids
834 append_todo_help
835 gettext "
John Keeping180bad32013-02-11 23:08:04 +0000836You are editing the todo file of an ongoing interactive rebase.
837To continue rebase after editing, run:
838 git rebase --continue
839
Vasco Almeidab8fc9e42016-06-17 20:21:04 +0000840" | git stripspace --comment-lines >>"$todo"
Andrew Wongeb9a7cb2012-09-17 21:28:09 -0400841
Wink Savilled48f97a2018-03-23 14:25:24 -0700842 git_sequence_editor "$todo" ||
843 die "$(gettext "Could not execute editor")"
844 expand_todo_ids
Andrew Wongeb9a7cb2012-09-17 21:28:09 -0400845
Wink Savilled48f97a2018-03-23 14:25:24 -0700846 exit
847 ;;
848 show-current-patch)
849 exec git show REBASE_HEAD --
850 ;;
Wink Saville27c499b2018-03-23 14:25:25 -0700851 *)
852 return 1 # continue
853 ;;
Wink Savilled48f97a2018-03-23 14:25:24 -0700854 esac
Wink Saville27c499b2018-03-23 14:25:25 -0700855}
Ramkumar Ramachandra26cd1602013-06-16 14:15:13 +0530856
Wink Saville27c499b2018-03-23 14:25:25 -0700857setup_reflog_action () {
Ramkumar Ramachandra26cd1602013-06-16 14:15:13 +0530858 comment_for_reflog start
Matt Kraai51668102007-09-25 18:30:13 -0700859
Wink Savilled48f97a2018-03-23 14:25:24 -0700860 if test ! -z "$switch_to"
Martin von Zweigbergk34262322011-02-06 13:43:35 -0500861 then
Wink Savilled48f97a2018-03-23 14:25:24 -0700862 GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: checkout $switch_to"
863 output git checkout "$switch_to" -- ||
864 die "$(eval_gettext "Could not checkout \$switch_to")"
865
866 comment_for_reflog start
Martin von Zweigbergk34262322011-02-06 13:43:35 -0500867 fi
Wink Saville27c499b2018-03-23 14:25:25 -0700868}
Martin von Zweigbergk34262322011-02-06 13:43:35 -0500869
Wink Saville27c499b2018-03-23 14:25:25 -0700870init_basic_state () {
Wink Savilled48f97a2018-03-23 14:25:24 -0700871 orig_head=$(git rev-parse --verify HEAD) || die "$(gettext "No HEAD?")"
872 mkdir -p "$state_dir" || die "$(eval_gettext "Could not create temporary \$state_dir")"
873 rm -f "$(git rev-parse --git-path REBASE_HEAD)"
Neil Horman90e18182012-04-20 10:36:17 -0400874
Wink Savilled48f97a2018-03-23 14:25:24 -0700875 : > "$state_dir"/interactive || die "$(gettext "Could not mark as interactive")"
876 write_basic_state
Wink Saville27c499b2018-03-23 14:25:25 -0700877}
878
879init_revisions_and_shortrevisions () {
880 shorthead=$(git rev-parse --short $orig_head)
881 shortonto=$(git rev-parse --short $onto)
882 if test -z "$rebase_root"
883 # this is now equivalent to ! -z "$upstream"
884 then
885 shortupstream=$(git rev-parse --short $upstream)
886 revisions=$upstream...$orig_head
887 shortrevisions=$shortupstream..$shorthead
888 else
889 revisions=$onto...$orig_head
890 shortrevisions=$shorthead
891 fi
892}
893
894complete_action() {
895 test -s "$todo" || echo noop >> "$todo"
896 test -z "$autosquash" || git rebase--helper --rearrange-squash || exit
897 test -n "$cmd" && git rebase--helper --add-exec-commands "$cmd"
898
899 todocount=$(git stripspace --strip-comments <"$todo" | wc -l)
900 todocount=${todocount##* }
901
902cat >>"$todo" <<EOF
903
904$comment_char $(eval_ngettext \
905 "Rebase \$shortrevisions onto \$shortonto (\$todocount command)" \
906 "Rebase \$shortrevisions onto \$shortonto (\$todocount commands)" \
907 "$todocount")
908EOF
909 append_todo_help
910 gettext "
911 However, if you remove everything, the rebase will be aborted.
912
913 " | git stripspace --comment-lines >>"$todo"
914
915 if test -z "$keep_empty"
916 then
917 printf '%s\n' "$comment_char $(gettext "Note that empty commits are commented out")" >>"$todo"
918 fi
919
920
921 has_action "$todo" ||
922 return 2
923
924 cp "$todo" "$todo".backup
925 collapse_todo_ids
926 git_sequence_editor "$todo" ||
927 die_abort "$(gettext "Could not execute editor")"
928
929 has_action "$todo" ||
930 return 2
931
932 git rebase--helper --check-todo-list || {
933 ret=$?
934 checkout_onto
935 exit $ret
936 }
937
938 expand_todo_ids
939
940 test -d "$rewritten" || test -n "$force_rebase" ||
941 onto="$(git rebase--helper --skip-unnecessary-picks)" ||
942 die "Could not skip unnecessary pick commands"
943
944 checkout_onto
945 if test -z "$rebase_root" && test ! -d "$rewritten"
946 then
947 require_clean_work_tree "rebase"
948 exec git rebase--helper ${force_rebase:+--no-ff} $allow_empty_message \
949 --continue
950 fi
951 do_rest
952}
953
954git_rebase__interactive () {
955 initiate_action "$action"
956 ret=$?
957 if test $ret = 0; then
958 return 0
959 fi
960
961 setup_reflog_action
962 init_basic_state
963
Wink Saville27c499b2018-03-23 14:25:25 -0700964 init_revisions_and_shortrevisions
965
Wink Savillec04549b2018-03-23 14:25:27 -0700966 git rebase--helper --make-script ${keep_empty:+--keep-empty} \
967 $revisions ${restrict_revision+^$restrict_revision} >"$todo" ||
968 die "$(gettext "Could not generate todo list")"
Wink Savilled48f97a2018-03-23 14:25:24 -0700969
Wink Saville27c499b2018-03-23 14:25:25 -0700970 complete_action
Kyle J. McKay9f50d322014-04-11 01:28:17 -0700971}
Wink Saville950b4872018-03-23 14:25:26 -0700972
973git_rebase__interactive__preserve_merges () {
974 initiate_action "$action"
975 ret=$?
976 if test $ret = 0; then
977 return 0
978 fi
979
980 setup_reflog_action
981 init_basic_state
982
Wink Savilleca3d4462018-03-23 14:25:28 -0700983 if test -z "$rebase_root"
Wink Saville950b4872018-03-23 14:25:26 -0700984 then
Wink Savilleca3d4462018-03-23 14:25:28 -0700985 mkdir "$rewritten" &&
986 for c in $(git merge-base --all $orig_head $upstream)
987 do
988 echo $onto > "$rewritten"/$c ||
Wink Saville950b4872018-03-23 14:25:26 -0700989 die "$(gettext "Could not init rewritten commits")"
Wink Savilleca3d4462018-03-23 14:25:28 -0700990 done
Wink Saville950b4872018-03-23 14:25:26 -0700991 else
Wink Savilleca3d4462018-03-23 14:25:28 -0700992 mkdir "$rewritten" &&
993 echo $onto > "$rewritten"/root ||
994 die "$(gettext "Could not init rewritten commits")"
Wink Saville950b4872018-03-23 14:25:26 -0700995 fi
996
997 init_revisions_and_shortrevisions
998
Wink Savilleca3d4462018-03-23 14:25:28 -0700999 format=$(git config --get rebase.instructionFormat)
1000 # the 'rev-list .. | sed' requires %m to parse; the instruction requires %H to parse
Wink Savillef24cd412018-03-23 14:25:29 -07001001 git rev-list --format="%m%H ${format:-%s}" \
Wink Savilleca3d4462018-03-23 14:25:28 -07001002 --reverse --left-right --topo-order \
1003 $revisions ${restrict_revision+^$restrict_revision} | \
1004 sed -n "s/^>//p" |
1005 while read -r sha1 rest
1006 do
Wink Savilleca3d4462018-03-23 14:25:28 -07001007 if test -z "$keep_empty" && is_empty_commit $sha1 && ! is_merge_commit $sha1
1008 then
1009 comment_out="$comment_char "
1010 else
1011 comment_out=
1012 fi
Wink Saville950b4872018-03-23 14:25:26 -07001013
Wink Savilleca3d4462018-03-23 14:25:28 -07001014 if test -z "$rebase_root"
1015 then
1016 preserve=t
1017 for p in $(git rev-list --parents -1 $sha1 | cut -d' ' -s -f2-)
1018 do
1019 if test -f "$rewritten"/$p
1020 then
1021 preserve=f
1022 fi
1023 done
1024 else
1025 preserve=f
1026 fi
1027 if test f = "$preserve"
1028 then
1029 touch "$rewritten"/$sha1
1030 printf '%s\n' "${comment_out}pick $sha1 $rest" >>"$todo"
1031 fi
1032 done
Wink Saville950b4872018-03-23 14:25:26 -07001033
1034 # Watch for commits that been dropped by --cherry-pick
Wink Savilleca3d4462018-03-23 14:25:28 -07001035 mkdir "$dropped"
1036 # Save all non-cherry-picked changes
1037 git rev-list $revisions --left-right --cherry-pick | \
1038 sed -n "s/^>//p" > "$state_dir"/not-cherry-picks
1039 # Now all commits and note which ones are missing in
1040 # not-cherry-picks and hence being dropped
1041 git rev-list $revisions |
1042 while read rev
1043 do
1044 if test -f "$rewritten"/$rev &&
1045 ! sane_grep "$rev" "$state_dir"/not-cherry-picks >/dev/null
1046 then
1047 # Use -f2 because if rev-list is telling us this commit is
1048 # not worthwhile, we don't want to track its multiple heads,
1049 # just the history of its first-parent for others that will
1050 # be rebasing on top of it
1051 git rev-list --parents -1 $rev | cut -d' ' -s -f2 > "$dropped"/$rev
1052 sha1=$(git rev-list -1 $rev)
1053 sane_grep -v "^[a-z][a-z]* $sha1" <"$todo" > "${todo}2" ; mv "${todo}2" "$todo"
1054 rm "$rewritten"/$rev
1055 fi
1056 done
Wink Saville950b4872018-03-23 14:25:26 -07001057
1058 complete_action
1059}